      *======================================================================                 RADDAT
      *   Common Jahreskonferenz 2009.                                                        RADDAT
      *======================================================================                 RADDAT
      *   Erzeugen RPG Service Programm:                                                      RADDAT
      *                                                                                       RADDAT
      *      CRTSQLRPGI OBJ(JAKO2009/RTVSYSSTS) OBJTYPE(*MODULE)                              RADDAT
      *         SRCFILE(JAKO2009/QSRC) SRCMBR(RTVSYSSTS) OPTION(*SYS)                         RADDAT
      *         COMMIT(*NONE) RDB(*NONE) DATFMT(*ISO) TIMFMT(*ISO)                            RADDAT
      *         CLOSQLCSR(*ENDACTGRP) DBGVIEW(*SOURCE)                                        RADDAT
      *                                                                                       RADDAT
      *      CRTSRVPGM  SRVPGM(JAKO2009/DATATYPES)                                            RADDAT
      *         MODULE(JAKO2009/DATATYPES) EXPORT(*ALL)                                       RADDAT
      *         TEXT('Web Service: Data Types')                                               RADDAT
      *                                                                                       RADDAT
      *======================================================================                 RADDAT
      *   Erzeugen Stored Procedures:                                                         RADDAT
      *                                                                                       RADDAT
      *   CREATE PROCEDURE jako2009.DataTypes_echo(                                           RADDAT
      *                                         IN boolean   CHAR(1)      ,                   RADDAT
      *                                         IN small     SMALLINT     ,                   RADDAT
      *                                         IN integer   INTEGER      ,                   RADDAT
      *                                         IN bigInt    BIGINT       ,                   RADDAT
      *                                         IN float     REAL         ,                   RADDAT
      *                                         IN "double"  DOUBLE       ,                   RADDAT
      *                                         IN packed    DECIMAL(9, 2),                   RADDAT
      *                                         IN zoned     NUMERIC(7, 3),                   RADDAT
      *                                         IN string    VARCHAR(80)  ,                   RADDAT
      *                                         IN date      DATE         ,                   RADDAT
      *                                         IN time      TIME         ,                   RADDAT
      *                                         IN timestamp TIMESTAMP    )                   RADDAT
      *      EXTERNAL NAME 'JAKO2009/DATATYPES(DataTypes_echo)'                               RADDAT
      *      LANGUAGE RPGLE                                                                   RADDAT
      *      PARAMETER STYLE GENERAL                                                          RADDAT
      *      DETERMINISTIC                                                                    RADDAT
      *                                                                                       RADDAT
      *======================================================================                 RADDAT
      *   Lschen Stored Procedures:                                                          RADDAT
      *                                                                                       RADDAT
      *   DROP   PROCEDURE jako2009.DataTypes_echo(                                           RADDAT
      *                                                      CHAR(1)      ,                   RADDAT
      *                                                      SMALLINT     ,                   RADDAT
      *                                                      INTEGER      ,                   RADDAT
      *                                                      BIGINT       ,                   RADDAT
      *                                                      REAL         ,                   RADDAT
      *                                                      DOUBLE       ,                   RADDAT
      *                                                      DECIMAL(9, 2),                   RADDAT
      *                                                      NUMERIC(7, 3),                   RADDAT
      *                                                      VARCHAR(80)  ,                   RADDAT
      *                                                      DATE         ,                   RADDAT
      *                                                      TIME         ,                   RADDAT
      *                                                      TIMESTAMP    )                   RADDAT
      *                                                                                       RADDAT
      *======================================================================                 RADDAT
      * >>PRE-COMPILER<<                                                                      RADDAT
      *   >>CRTCMD<< CRTSQLRPGI   OBJ(&LI/&OB) +                                              RADDAT
      *                           SRCFILE(&SL/&SF) +                                          RADDAT
      *                           SRCMBR(&SM);                                                RADDAT
      *   >>COMPILE<<                                                                         RADDAT
      *     >>PARM<< OBJTYPE(*MODULE);                                                        RADDAT
      *     >>PARM<< OPTION(*SYS);                                                            RADDAT
      *     >>PARM<< COMMIT(*NONE);                                                           RADDAT
      *     >>PARM<< RDB(*NONE);                                                              RADDAT
      *     >>PARM<< DATFMT(*ISO);                                                            RADDAT
      *     >>PARM<< TIMFMT(*ISO);                                                            RADDAT
      *     >>PARM<< OUTPUT(*PRINT);                                                          RADDAT
      *     >>PARM<< CLOSQLCSR(*ENDACTGRP);                                                   RADDAT
      *     >>PARM<< DBGVIEW(*SOURCE);                                                        RADDAT
      *     >>PARM<< TGTRLS(V5R2M0);                                                          RADDAT
      *   >>END-COMPILE<<                                                                     RADDAT
      *   >>EXECUTE<<                                                                         RADDAT
      *   >>CMD<<    CRTSRVPGM +                                                              RADDAT
      *              SRVPGM(&LI/&OB) +                                                        RADDAT
      *              MODULE(&LI/&OB) +                                                        RADDAT
      *              EXPORT(*ALL) +                                                           RADDAT
      *              ACTGRP(DATATYPES) +                                                      RADDAT
      *              TEXT('+                                                                  RADDAT
      *              Web Service: Data Types+                                                 RADDAT
      *              ') +                                                                     RADDAT
      *              DETAIL(*BASIC) +                                                         RADDAT
      *              TGTRLS(V5R2M0);                                                          RADDAT
      * >>END-PRE-COMPILER<<                                                                  RADDAT
      *======================================================================                 RADDAT
     H NOMAIN                                                                                 RADDAT
     H DEBUG OPTION(*SRCSTMT : *NODEBUGIO)                                                    RADDAT
     H DECEDIT('0,') DATEDIT(*DMY.)                                                           RADDAT
     H DATFMT(*ISO ) TIMFMT(*ISO )                                                            RADDAT
     H EXPROPTS(*RESDECPOS)                                                                   RADDAT
     H EXTBININT(*YES)                                                                        RADDAT
      *                                                                                       RADDAT
      * ------------------------------------                                                  RADDAT
      *  Type definitions                                                                     RADDAT
      * ------------------------------------                                                  RADDAT
     D dataTypes_t...                                                                         RADDAT
     D                 DS                  qualified               based(pDummy)              RADDAT
     D  boolean                        N                                                      RADDAT
     D  small                         5I 0                                                    RADDAT
     D  integer                      10I 0                                                    RADDAT
     D  bigInt                       20I 0                                                    RADDAT
     D  float                         4F                                                      RADDAT
     D  double                        8F                                                      RADDAT
     D  packed                        9P 2                                                    RADDAT
     D  zoned                         7S 3                                                    RADDAT
     D  string                       80A   varying                                            RADDAT
     D  date                           D                                                      RADDAT
     D  time                           T                                                      RADDAT
     D  timestamp                      Z                                                      RADDAT
      *                                                                                       RADDAT
     D errCode_t       DS                  qualified           based(pDummy)                  RADDAT
     D  bytPrv                       10I 0                                                    RADDAT
     D  bytAvl                       10I 0                                                    RADDAT
     D  excID                         7A                                                      RADDAT
     D  reserved_1                    1A                                                      RADDAT
     D  excDta                      256A                                                      RADDAT
      *                                                                                       RADDAT
      * ------------------------------------                                                  RADDAT
      *  Exported procedures                                                                  RADDAT
      * ------------------------------------                                                  RADDAT
      *                                                                                       RADDAT
     D DataTypes_echo...                                                                      RADDAT
     D                 PR                                                                     RADDAT
     D                                     extproc('+                                         RADDAT
     D                                     DataTypes_echo+                                    RADDAT
     D                                     ')                                                 RADDAT
     D  i_boolean                          const  like(dataTypes_t.boolean   )                RADDAT
     D  i_small                            const  like(dataTypes_t.small     )                RADDAT
     D  i_integer                          const  like(dataTypes_t.integer   )                RADDAT
     D  i_bigInt                           const  like(dataTypes_t.bigInt    )                RADDAT
     D  i_float                            const  like(dataTypes_t.float     )                RADDAT
     D  i_double                           const  like(dataTypes_t.double    )                RADDAT
     D  i_packed                           const  like(dataTypes_t.packed    )                RADDAT
     D  i_zoned                            const  like(dataTypes_t.zoned     )                RADDAT
     D  i_string                           const  like(dataTypes_t.string    )                RADDAT
     D  i_date                             const  like(dataTypes_t.date      )                RADDAT
     D  i_time                             const  like(dataTypes_t.time      )                RADDAT
     D  i_timestamp                        const  like(dataTypes_t.timestamp )                RADDAT
      *                                                                                       RADDAT
      * ------------------------------------                                                  RADDAT
      *  Internal procedures                                                                  RADDAT
      * ------------------------------------                                                  RADDAT
      *                                                                                       RADDAT
      * =====================================================================                 RADDAT
      *  Echos the values passed to this procedure.                                           RADDAT
      * =====================================================================                 RADDAT
      *  Parameters:                                                                          RADDAT
      *   i_reset          Reset status statistics.                                           RADDAT
      *                     *YES  Statistics will be reset to zero.                           RADDAT
      *                     *NO   Statistics will not be reset to zero.                       RADDAT
      *                                                                                       RADDAT
      *  Returns:                                                                             RADDAT
      *   dataTypes        Result set with one row of type 'dataTypes_t'.                     RADDAT
      * =====================================================================                 RADDAT
     P DataTypes_echo...                                                                      RADDAT
     P                 B                   export                                             RADDAT
     D DataTypes_echo...                                                                      RADDAT
     D                 PI                                                                     RADDAT
     D  i_boolean                          const  like(dataTypes_t.boolean   )                RADDAT
     D  i_small                            const  like(dataTypes_t.small     )                RADDAT
     D  i_integer                          const  like(dataTypes_t.integer   )                RADDAT
     D  i_bigInt                           const  like(dataTypes_t.bigInt    )                RADDAT
     D  i_float                            const  like(dataTypes_t.float     )                RADDAT
     D  i_double                           const  like(dataTypes_t.double    )                RADDAT
     D  i_packed                           const  like(dataTypes_t.packed    )                RADDAT
     D  i_zoned                            const  like(dataTypes_t.zoned     )                RADDAT
     D  i_string                           const  like(dataTypes_t.string    )                RADDAT
     D  i_date                             const  like(dataTypes_t.date      )                RADDAT
     D  i_time                             const  like(dataTypes_t.time      )                RADDAT
     D  i_timestamp                        const  like(dataTypes_t.timestamp )                RADDAT
      *                                                                                       RADDAT
      *  Return value                                                                         RADDAT
     D dataTypes       DS                  likeds(dataTypes_t   ) inz                         RADDAT
     D                                     dim(1)                                             RADDAT
     D numRows         S             10I 0 inz(%elem(dataTypes))                              RADDAT
      *                                                                                       RADDAT
      *  Local fields                                                                         RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -               RADDAT
      /free
                                                                                            //RADDAT
         dataTypes(1).boolean   = i_boolean;                                                //RADDAT
         dataTypes(1).small     = i_small;                                                  //RADDAT
         dataTypes(1).integer   = i_integer;                                                //RADDAT
         dataTypes(1).bigInt    = i_bigInt;                                                 //RADDAT
         dataTypes(1).float     = i_float;                                                  //RADDAT
         dataTypes(1).double    = i_double;                                                 //RADDAT
         dataTypes(1).packed    = i_packed;                                                 //RADDAT
         dataTypes(1).zoned     = i_zoned;                                                  //RADDAT
         dataTypes(1).string    = i_string;                                                 //RADDAT
         dataTypes(1).date      = i_date;                                                   //RADDAT
         dataTypes(1).time      = i_time;                                                   //RADDAT
         dataTypes(1).timestamp = i_timestamp;                                              //RADDAT
                                                                                            //RADDAT
         EXEC SQL
          SET RESULT SETS FOR RETURN TO CALLER ARRAY :dataTypes
                                                 FOR :numRows      ROWS;                    //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P DataTypes_echo...                                                                      RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
