package de.tools400.jako2009.webservice.retrievesystemstatus.test;

import de.tools400.jako2009.webservice.retrievesystemstatus.server.AdvancedStatusRequest;
import de.tools400.jako2009.webservice.retrievesystemstatus.server.AdvancedStatusResponse;
import de.tools400.jako2009.webservice.retrievesystemstatus.server.SystemStatusService;

public class TestRetrieveAdvancedStatus {

	/**
	 * Prft nur, ob der Aufruf der Stored Procedure funktioniert.
	 * Prft nicht, ob der Web Service funktioniert.
	 */
	public static void main(String[] args) {
		
		SystemStatusService aService = new SystemStatusService();
		
		AdvancedStatusRequest aRequest = new AdvancedStatusRequest();
		aRequest.setReset(false);
		
		AdvancedStatusResponse aResponse = aService.retrieveAdvancedStatus(aRequest);
		
		System.out.println("Advanced System Status:\n");
		System.out.println("  Jobs in system                  : " + aResponse.getJobsInSystem());
		System.out.println("  Active jobs in system           : " + aResponse.getActiveJobsInSystem());
		
	}

}
