package de.tools400.jako2009.webservice.retrievesystemstatus.test;

import de.tools400.jako2009.webservice.retrievesystemstatus.server.PoolStatus;
import de.tools400.jako2009.webservice.retrievesystemstatus.server.PoolStatusInformationRequest;
import de.tools400.jako2009.webservice.retrievesystemstatus.server.PoolStatusInformationResponse;
import de.tools400.jako2009.webservice.retrievesystemstatus.server.SystemStatusService;

public class TestRetrievePoolStatusInformation {

	/**
	 * Prft nur, ob der Aufruf der Stored Procedure funktioniert.
	 * Prft nicht, ob der Web Service funktioniert.
	 */
	public static void main(String[] args) {
		
		SystemStatusService aService = new SystemStatusService();
		
		PoolStatusInformationRequest aRequest = new PoolStatusInformationRequest();
		aRequest.setReset(false);
		
		PoolStatusInformationResponse aResponse = aService.retrievePoolStatusInformation(aRequest);
		PoolStatus aPoolStatus[] = aResponse.getPoolStatus();
		
		System.out.println("System Pool Information:\n");
		for (int i = 0; i < aPoolStatus.length; i++) {
			System.out.println("  Pool name                      : " + aPoolStatus[i].getPoolName());
			System.out.println("  Pool size                      : " + aPoolStatus[i].getPoolSize());
			System.out.println();
		}
		
	}

}
