      *======================================================================                 RADDAT
      *   Common Jahreskonferenz 2009.                                                        RADDAT
      *======================================================================                 RADDAT
      *   Erzeugen RPG Service Programm:                                                      RADDAT
      *                                                                                       RADDAT
      *      CRTSQLRPGI OBJ(JAKO2009/RTVSYSSTS) OBJTYPE(*MODULE)                              RADDAT
      *         SRCFILE(JAKO2009/QSRC) SRCMBR(RTVSYSSTS) OPTION(*SYS)                         RADDAT
      *         COMMIT(*NONE) RDB(*NONE) DATFMT(*ISO) TIMFMT(*ISO)                            RADDAT
      *         CLOSQLCSR(*ENDACTGRP) DBGVIEW(*SOURCE)                                        RADDAT
      *                                                                                       RADDAT
      *      CRTSRVPGM  SRVPGM(JAKO2009/RTVSYSSTS)                                            RADDAT
      *         MODULE(JAKO2009/RTVSYSSTS) EXPORT(*ALL)                                       RADDAT
      *         TEXT('Web Service: Retrieve System Status')                                   RADDAT
      *                                                                                       RADDAT
      *======================================================================                 RADDAT
      *   Erzeugen Stored Procedures:                                                         RADDAT
      *                                                                                       RADDAT
      *   CREATE PROCEDURE jako2009.RetrieveSystemStatus_basic(                               RADDAT
      *                                         IN  reset     VARCHAR(10))                    RADDAT
      *      EXTERNAL NAME                                                                    RADDAT
      *         'JAKO2009/RTVSYSSTS(RetrieveSystemStatus_basic)'                              RADDAT
      *      LANGUAGE RPGLE                                                                   RADDAT
      *      PARAMETER STYLE GENERAL                                                          RADDAT
      *      NOT DETERMINISTIC                                                                RADDAT
      *      DYNAMIC RESULT SET 1                                                             RADDAT
      *                                                                                       RADDAT
      *   CREATE PROCEDURE jako2009.RetrieveSystemStatus_advanced(                            RADDAT
      *                                         IN  reset     VARCHAR(10))                    RADDAT
      *      EXTERNAL NAME                                                                    RADDAT
      *         'JAKO2009/RTVSYSSTS(RetrieveSystemStatus_advanced)'                           RADDAT
      *      LANGUAGE RPGLE                                                                   RADDAT
      *      PARAMETER STYLE GENERAL                                                          RADDAT
      *      NOT DETERMINISTIC                                                                RADDAT
      *      DYNAMIC RESULT SET 1                                                             RADDAT
      *                                                                                       RADDAT
      *   CREATE PROCEDURE jako2009.RetrieveSystemStatus_poolInformation(                     RADDAT
      *                                         IN  reset     VARCHAR(10))                    RADDAT
      *      EXTERNAL NAME                                                                    RADDAT
      *         'JAKO2009/RTVSYSSTS(RetrieveSystemStatus_poolInformation)'                    RADDAT
      *      LANGUAGE RPGLE                                                                   RADDAT
      *      PARAMETER STYLE GENERAL                                                          RADDAT
      *      NOT DETERMINISTIC                                                                RADDAT
      *      DYNAMIC RESULT SET 1                                                             RADDAT
      *                                                                                       RADDAT
      *   CREATE PROCEDURE jako2009.RetrieveSystemStatus_about(                               RADDAT
      *                                         OUT version   VARCHAR(  10),                  RADDAT
      *                                         OUT copyright VARCHAR( 512),                  RADDAT
      *                                         OUT info      VARCHAR(1024))                  RADDAT
      *      EXTERNAL NAME                                                                    RADDAT
      *         'JAKO2009/RTVSYSSTS(RetrieveSystemStatus_about)'                              RADDAT
      *      LANGUAGE RPGLE                                                                   RADDAT
      *      PARAMETER STYLE GENERAL                                                          RADDAT
      *      DETERMINISTIC                                                                    RADDAT
      *                                                                                       RADDAT
      *======================================================================                 RADDAT
      *   Lschen Stored Procedures:                                                          RADDAT
      *                                                                                       RADDAT
      *   DROP   PROCEDURE jako2009.RetrieveSystemStatus_basic(                               RADDAT
      *                                                       VARCHAR(10))                    RADDAT
      *                                                                                       RADDAT
      *   DROP   PROCEDURE jako2009.RetrieveSystemStatus_advanced(                            RADDAT
      *                                                       VARCHAR(10))                    RADDAT
      *                                                                                       RADDAT
      *   DROP   PROCEDURE jako2009.RetrieveSystemStatus_poolInformation(                     RADDAT
      *                                                       VARCHAR(10))                    RADDAT
      *                                                                                       RADDAT
      *   DROP   PROCEDURE jako2009.RetrieveSystemStatus_about(                               RADDAT
      *                                                       VARCHAR(  10),                  RADDAT
      *                                                       VARCHAR( 512),                  RADDAT
      *                                                       VARCHAR(1024))                  RADDAT
      *                                                                                       RADDAT
      *======================================================================                 RADDAT
      * >>PRE-COMPILER<<                                                                      RADDAT
      *   >>CRTCMD<< CRTSQLRPGI   OBJ(&LI/&OB) +                                              RADDAT
      *                           SRCFILE(&SL/&SF) +                                          RADDAT
      *                           SRCMBR(&SM);                                                RADDAT
      *   >>COMPILE<<                                                                         RADDAT
      *     >>PARM<< OBJTYPE(*MODULE);                                                        RADDAT
      *     >>PARM<< OPTION(*SYS);                                                            RADDAT
      *     >>PARM<< COMMIT(*NONE);                                                           RADDAT
      *     >>PARM<< RDB(*NONE);                                                              RADDAT
      *     >>PARM<< DATFMT(*ISO);                                                            RADDAT
      *     >>PARM<< TIMFMT(*ISO);                                                            RADDAT
      *     >>PARM<< OUTPUT(*PRINT);                                                          RADDAT
      *     >>PARM<< CLOSQLCSR(*ENDACTGRP);                                                   RADDAT
      *     >>PARM<< DBGVIEW(*SOURCE);                                                        RADDAT
      *     >>PARM<< TGTRLS(V5R2M0);                                                          RADDAT
      *   >>END-COMPILE<<                                                                     RADDAT
      *   >>EXECUTE<<                                                                         RADDAT
      *   >>CMD<<    CRTSRVPGM +                                                              RADDAT
      *              SRVPGM(&LI/&OB) +                                                        RADDAT
      *              MODULE(&LI/&OB) +                                                        RADDAT
      *              EXPORT(*ALL) +                                                           RADDAT
      *              TEXT('+                                                                  RADDAT
      *              Web Service: Retrieve System Status+                                     RADDAT
      *              ') +                                                                     RADDAT
      *              DETAIL(*BASIC) +                                                         RADDAT
      *              TGTRLS(V5R2M0);                                                          RADDAT
      * >>END-PRE-COMPILER<<                                                                  RADDAT
      *======================================================================                 RADDAT
     H NOMAIN                                                                                 RADDAT
     H DEBUG OPTION(*SRCSTMT : *NODEBUGIO)                                                    RADDAT
     H DECEDIT('0,') DATEDIT(*DMY.)                                                           RADDAT
     H DATFMT(*ISO ) TIMFMT(*ISO )                                                            RADDAT
     H EXPROPTS(*RESDECPOS)                                                                   RADDAT
     H EXTBININT(*YES)                                                                        RADDAT
      *                                                                                       RADDAT
      * ------------------------------------                                                  RADDAT
      *  Type definitions                                                                     RADDAT
      * ------------------------------------                                                  RADDAT
     D basicStatus_t...                                                                       RADDAT
     D                 DS                  qualified               based(pDummy)              RADDAT
     D  systemName                    8A                                                      RADDAT
     D  currentTime                    Z                                                      RADDAT
     D  usersCurrentlySignedOn...                                                             RADDAT
     D                               10I 0                                                    RADDAT
     D  batchJobsWaitingForMessages...                                                        RADDAT
     D                               10I 0                                                    RADDAT
     D  batchJobsRunning...                                                                   RADDAT
     D                               10I 0                                                    RADDAT
     D  batchJobsHeldWhileRunning...                                                          RADDAT
     D                               10I 0                                                    RADDAT
     D  batchJobsHeldOnJobQueue...                                                            RADDAT
     D                               10I 0                                                    RADDAT
     D  batchJobsOnAHeldJobQueue...                                                           RADDAT
     D                               10I 0                                                    RADDAT
     D  batchJobsOnUnassignedJobQueue...                                                      RADDAT
     D                               10I 0                                                    RADDAT
      *                                                                                       RADDAT
     D advancedStatus_t...                                                                    RADDAT
     D                 DS                  qualified               based(pDummy)              RADDAT
     D  systemName                    8A                                                      RADDAT
     D  currentTime                    Z                                                      RADDAT
     D  elapsedTime                    T                                                      RADDAT
     D  percentProcessingUnitUsed...                                                          RADDAT
     D                               10I 0                                                    RADDAT
     D  jobsInSystem...                                                                       RADDAT
     D                               10I 0                                                    RADDAT
     D  percentPermanentAddresses...                                                          RADDAT
     D                               10I 0                                                    RADDAT
     D  percentTemporaryAddresses...                                                          RADDAT
     D                               10I 0                                                    RADDAT
     D  systemASP...                                                                          RADDAT
     D                               10I 0                                                    RADDAT
     D  percentSystemASPUsed...                                                               RADDAT
     D                               10I 0                                                    RADDAT
     D  totalAuxiliaryStorage...                                                              RADDAT
     D                               10I 0                                                    RADDAT
     D  numberOfProcessors...                                                                 RADDAT
     D                               10I 0                                                    RADDAT
     D  activeJobsInSystem...                                                                 RADDAT
     D                               10I 0                                                    RADDAT
     D  mainStorageSize...                                                                    RADDAT
     D                               20I 0                                                    RADDAT
     D  currentDate                    D                                                      RADDAT
      *                                                                                       RADDAT
     D poolInformation_t...                                                                   RADDAT
     D                 DS                  qualified               based(pDummy)              RADDAT
     D  systemName                    8A                                                      RADDAT
     D  currentTime                    Z                                                      RADDAT
     D  elapsedTime                    T                                                      RADDAT
     D  systemPool                   10I 0                                                    RADDAT
     D  poolSize                     10I 0                                                    RADDAT
     D  reservedSize                 10I 0                                                    RADDAT
     D  maxActThd                    10I 0                                                    RADDAT
     D  db_faults                    10I 0                                                    RADDAT
     D  db_pages                     10I 0                                                    RADDAT
     D  nonDB_faults                 10I 0                                                    RADDAT
     D  nonDB_pages                  10I 0                                                    RADDAT
     D  actToWait                    10I 0                                                    RADDAT
     D  waitToIneligible...                                                                   RADDAT
     D                               10I 0                                                    RADDAT
     D  activeToIneligible...                                                                 RADDAT
     D                               10I 0                                                    RADDAT
     D  poolName                     10A                                                      RADDAT
     D  sbsName                      10A                                                      RADDAT
     D  sbsLibName                   10A                                                      RADDAT
     D  pagingOption                 10A                                                      RADDAT
      *                                                                                       RADDAT
     D errCode_t...                                                                           RADDAT
     D                 DS                  qualified               based(pDummy)              RADDAT
     D  bytPrv                       10I 0                                                    RADDAT
     D  bytAvl                       10I 0                                                    RADDAT
     D  excpID                        7A                                                      RADDAT
     D  reserved_1                    1A                                                      RADDAT
     D  excpData                    256A                                                      RADDAT
      *                                                                                       RADDAT
     D CRLF            C                   x'0D25'                                            RADDAT
      *                                                                                       RADDAT
      * ------------------------------------                                                  RADDAT
      *  Exported procedures                                                                  RADDAT
      * ------------------------------------                                                  RADDAT
      *  Sets the content type and the SOAP action of the POST message.                       RADDAT
     D RetrieveSystemStatus_basic...                                                          RADDAT
     D                 PR                                                                     RADDAT
     D                                     extproc('+                                         RADDAT
     D                                     RetrieveSystemStatus_basic+                        RADDAT
     D                                     ')                                                 RADDAT
     D  i_reset                      10A   const  varying                                     RADDAT
      *                                                                                       RADDAT
      *  Retrieves advanced system status information.                                        RADDAT
     D RetrieveSystemStatus_advanced...                                                       RADDAT
     D                 PR                                                                     RADDAT
     D                                     extproc('+                                         RADDAT
     D                                     RetrieveSystemStatus_advanced+                     RADDAT
     D                                     ')                                                 RADDAT
     D  i_reset                      10A   const  varying                                     RADDAT
      *                                                                                       RADDAT
      *  Retrieves system pool information.                                                   RADDAT
     D RetrieveSystemStatus_poolInformation...                                                RADDAT
     D                 PR                                                                     RADDAT
     D                                     extproc('+                                         RADDAT
     D                                     RetrieveSystemStatus_poolInformation+              RADDAT
     D                                     ')                                                 RADDAT
     D  i_reset                      10A   const  varying                                     RADDAT
      *                                                                                       RADDAT
      *  Returns 'about' information about the RetrieveSystemStatus                           RADDAT
      *  web service.                                                                         RADDAT
     D RetrieveSystemStatus_about...                                                          RADDAT
     D                 PR                                                                     RADDAT
     D                                     extproc('+                                         RADDAT
     D                                     RetrieveSystemStatus_about+                        RADDAT
     D                                     ')                                                 RADDAT
     D  o_version                    10A          varying                                     RADDAT
     D  o_copyright                 512A          varying                                     RADDAT
     D  o_info                     1024A          varying                                     RADDAT
      *                                                                                       RADDAT
      *  Returns the qualified name of the current job.                                       RADDAT
     D getJob...                                                                              RADDAT
     D                 PR            26A   varying                                            RADDAT
     D                                     extproc('+                                         RADDAT
     D                                     getJob+                                            RADDAT
     D                                     ')                                                 RADDAT
      *                                                                                       RADDAT
      *  Converts a given system timestamp as returned by several APIs                        RADDAT
      *  to a RPG timestamp value.                                                            RADDAT
     D convertSysTimestampToRpg...                                                            RADDAT
     D                 PR              Z                                                      RADDAT
     D                                     extproc('+                                         RADDAT
     D                                     convertSysTimestampToRpg+                          RADDAT
     D                                     ')                                                 RADDAT
     D  i_sysTmstmp                   8A   const                                              RADDAT
      *                                                                                       RADDAT
      *  Kills the current process and sends a given message text.                            RADDAT
     D kill...                                                                                RADDAT
     D                 PR                                                                     RADDAT
     D                                     extproc('+                                         RADDAT
     D                                     kill+                                              RADDAT
     D                                     ')                                                 RADDAT
     D  i_text                      512A   const  varying                                     RADDAT
      *                                                                                       RADDAT
      * ------------------------------------                                                  RADDAT
      *  Imported procedures                                                                  RADDAT
      * ------------------------------------                                                  RADDAT
      *                                                                                       RADDAT
      *  Retrieve System Status (QWCRSSTS) API                                                RADDAT
     D QWCRSSTS...                                                                            RADDAT
     D                 PR                         extpgm('QWCRSSTS')                          RADDAT
     D  o_rcvVar                  65535A         options(*varsize)                            RADDAT
     D  i_lenRcvVar                  10I 0 const                                              RADDAT
     D  i_format                      8A   const                                              RADDAT
     D  i_reset                      10A   const                                              RADDAT
     D  io_errCode                65535A          options(*varsize)                           RADDAT
     D  i_poolSlcInf              65535A   const options(*nopass: *varsize)     | optGrp1     RADDAT
     D  i_sizePoolSlcInf...                                                     |             RADDAT
     D                               10I 0 const options(*nopass)               |             RADDAT
      *                                                                                       RADDAT
      *  SSTS0100 Format                                                                      RADDAT
     D ssts0100_t...                                                                          RADDAT
     D                 DS                  qualified               based(pDummy)              RADDAT
     D  bytAvl                 1      4I 0                                                    RADDAT
     D  bytRet                 5      8I 0                                                    RADDAT
     D  curDateTime            9     16A                                                      RADDAT
     D  systemName            17     24A                                                      RADDAT
     D  usrSgndOn             25     28I 0                                                    RADDAT
     D  usrTmpDsc             29     32I 0                                                    RADDAT
     D  usrSuspSysReq         33     36I 0                                                    RADDAT
     D  usrSuspGrpJob         37     40I 0                                                    RADDAT
     D  usrSgnOffPrtW         41     44I 0                                                    RADDAT
     D  jobMsgWait            45     48I 0                                                    RADDAT
     D  jobRun                49     52I 0                                                    RADDAT
     D  jobHeldRun            53     56I 0                                                    RADDAT
     D  jobEnding             57     60I 0                                                    RADDAT
     D  jobRunWait            61     64I 0                                                    RADDAT
     D  jobHeldOnJobQ         65     68I 0                                                    RADDAT
     D  jobOnHeldJobQ         69     72I 0                                                    RADDAT
     D  jobUnasndJobQ         73     76I 0                                                    RADDAT
     D  jobEndPrtW            77     80I 0                                                    RADDAT
      *                                                                                       RADDAT
      *  SSTS0200 Format                                                                      RADDAT
     D ssts0200_t...                                                                          RADDAT
     D                 DS                  qualified               based(pDummy)              RADDAT
     D  bytAvl                 1      4I 0                                                    RADDAT
     D  bytRet                 5      8I 0                                                    RADDAT
     D  curDateTime            9     16A                                                      RADDAT
     D  systemName            17     24A                                                      RADDAT
     D  elapTime              25     30A                                                      RADDAT
     D  rstrctdState          31     31A                                                      RADDAT
     D  reserved_1            32     32A                                                      RADDAT
     D  przPrcUsd             33     36I 0                                                    RADDAT
     D  jobs                  37     40I 0                                                    RADDAT
     D  przPrmAddr            41     44I 0                                                    RADDAT
     D  przTmpAddr            45     48I 0                                                    RADDAT
     D  sysASP                49     52I 0                                                    RADDAT
     D  przSysASPUsd          53     56I 0                                                    RADDAT
     D  totAuxStg             57     60I 0                                                    RADDAT
     D  curUnprStgUsd         61     64I 0                                                    RADDAT
     D  maxUnprStgUsd         65     68I 0                                                    RADDAT
     D  przDBCap              69     72I 0                                                    RADDAT
     D  mainStgSize           73     76I 0                                                    RADDAT
     D  numPart               77     80I 0                                                    RADDAT
     D  partID                81     84I 0                                                    RADDAT
     D  reserved_2            85     88I 0                                                    RADDAT
     D  curPrcngCap           89     92I 0                                                    RADDAT
     D  prcShdAttr            93     93A                                                      RADDAT
     D  reserved_3            94     96A                                                      RADDAT
     D  numPrc                97    100I 0                                                    RADDAT
     D  actJobs              101    104I 0                                                    RADDAT
     D  actThds              105    108I 0                                                    RADDAT
     D  maxJobs              109    112I 0                                                    RADDAT
     D  przTmpUsd256         113    116I 0                                                    RADDAT
     D  przTmpUsd4GB         117    120I 0                                                    RADDAT
     D  przPrmUsd256         121    124I 0                                                    RADDAT
     D  przPrmUsd4GB         125    128I 0                                                    RADDAT
     D  przCurIActPrf        129    132I 0                                                    RADDAT
     D  przUncCPUusd         133    136I 0                                                    RADDAT
     D  przShdPrcPUsd        137    140I 0                                                    RADDAT
     D  mainStgSizeLg        141    148U 0                                                    RADDAT
      *                                                                                       RADDAT
      *  SSTS0300 Format                                                                      RADDAT
     D ssts0300_t...                                                                          RADDAT
     D                 DS                  qualified               based(pDummy)              RADDAT
     D  bytAvl                 1      4I 0                                                    RADDAT
     D  bytRet                 5      8I 0                                                    RADDAT
     D  curDateTime            9     16A                                                      RADDAT
     D  systemName            17     24A                                                      RADDAT
     D  elapTime              25     30A                                                      RADDAT
     D  reserved_1            31     32A                                                      RADDAT
     D  numPools              33     36I 0                                                    RADDAT
     D  ofsPoolInf            37     40I 0                                                    RADDAT
     D  lenPoolInf            41     44I 0                                                    RADDAT
      *                                                                                       RADDAT
      *  SSTS0300 Format, Pool Information                                                    RADDAT
     D ssts0300_poolInf_t...                                                                  RADDAT
     D                 DS                  qualified               based(pDummy)              RADDAT
     D  systemPool             1      4I 0                                                    RADDAT
     D  poolSize               5      8I 0                                                    RADDAT
     D  reservedSize           9     12I 0                                                    RADDAT
     D  maxActThd             13     16I 0                                                    RADDAT
     D  db_faults             17     20I 0                                                    RADDAT
     D  db_pages              21     24I 0                                                    RADDAT
     D  nonDB_faults          25     28I 0                                                    RADDAT
     D  nonDB_pages           29     32I 0                                                    RADDAT
     D  actToWait             33     36I 0                                                    RADDAT
     D  waitToIneligible...                                                                   RADDAT
     D                        37     40I 0                                                    RADDAT
     D  activeToIneligible...                                                                 RADDAT
     D                        41     44I 0                                                    RADDAT
     D  poolName              45     54A                                                      RADDAT
     D  sbsName               55     64A                                                      RADDAT
     D  sbsLibName            65     74A                                                      RADDAT
     D  pagingOption          75     84A                                                      RADDAT
      *                                                                                       RADDAT
      * ------------------------------------                                                  RADDAT
      *  Program status information                                                           RADDAT
      * ------------------------------------                                                  RADDAT
     D sds            SDS                  qualified                                          RADDAT
     D  pgmName                1     10A                                                      RADDAT
     D  pgmStat               11     15S 0                                                    RADDAT
     D  prevStat              16     20S 0                                                    RADDAT
     D  lastSeq               21     28A                                                      RADDAT
     D  lastSubr              29     36A                                                      RADDAT
     D  nbrParm               37     39S 0                                                    RADDAT
     D  excType               40     42A                                                      RADDAT
     D  excNbr                43     46A                                                      RADDAT
     D  miInstruction         47     50A                                                      RADDAT
     D  workArea              51     80A                                                      RADDAT
     D  pgmLib                81     90A                                                      RADDAT
     D  excData               91    170A                                                      RADDAT
     D  rnx9001Exc           171    174A                                                      RADDAT
     D  lastFileLong         175    184A                                                      RADDAT
     D  unused_1             185    190A                                                      RADDAT
     D  datFmt               191    198A                                                      RADDAT
     D  year                 199    200S 0                                                    RADDAT
     D  lastFileShort        201    208A                                                      RADDAT
     D  fileStat             209    243A                                                      RADDAT
     D  job                  244    253A                                                      RADDAT
     D  user                 254    263A                                                      RADDAT
     D  nbr                  264    269S 0                                                    RADDAT
     D  startDate            270    275S 0                                                    RADDAT
     D  runDate              276    281S 0                                                    RADDAT
     D  runTime              282    287S 0                                                    RADDAT
     D  compDate             288    293A                                                      RADDAT
     D  compTime             294    299A                                                      RADDAT
     D  compLevel            300    303A                                                      RADDAT
     D  srcFile              304    313A                                                      RADDAT
     D  srcLib               314    323A                                                      RADDAT
     D  srcMbr               324    333A                                                      RADDAT
     D  pgmContProc          334    343A                                                      RADDAT
     D  modContProc          344    353A                                                      RADDAT
     D  unused_2             354    429A                                                      RADDAT
      *                                                                                       RADDAT
      * =====================================================================                 RADDAT
      *  Retrieves basic system status information.                                           RADDAT
      * =====================================================================                 RADDAT
      *  Parameters:                                                                          RADDAT
      *   i_reset          Reset status statistics.                                           RADDAT
      *                     *YES  Statistics will be reset to zero.                           RADDAT
      *                     *NO   Statistics will not be reset to zero.                       RADDAT
      *                                                                                       RADDAT
      *  Returns:                                                                             RADDAT
      *   basicStatus      Result set with one row of type 'basicStatus_t'.                   RADDAT
      * =====================================================================                 RADDAT
     P RetrieveSystemStatus_basic...                                                          RADDAT
     P                 B                   export                                             RADDAT
     D RetrieveSystemStatus_basic...                                                          RADDAT
     D                 PI                                                                     RADDAT
     D  i_reset                      10A   const  varying                                     RADDAT
      *                                                                                       RADDAT
      *  Return value                                                                         RADDAT
     D basicStatus     DS                  likeds(basicStatus_t ) inz                         RADDAT
     D                                     dim(1)                                             RADDAT
     D numRows         S             10I 0 inz(%elem(basicStatus))                            RADDAT
      *                                                                                       RADDAT
      *  Local fields                                                                         RADDAT
     D curTimestamp    S               Z   inz                                                RADDAT
     D ssts0100        DS                  likeds(ssts0100_t) inz                             RADDAT
     D errCode         DS                  likeds(errCode_t ) inz                             RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -               RADDAT
      /free
                                                                                            //RADDAT
 B01     if (i_reset <> '*YES' and i_reset <> '*NO');                                       //RADDAT
            kill('Value of parameter ''i_reset'' is invalid: ' + i_reset);                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         QWCRSSTS(ssts0100: %size(ssts0100): 'SSTS0100': i_reset: errCode);                 //RADDAT
                                                                                            //RADDAT
         curTimestamp = convertSysTimestampToRpg(ssts0100.curDateTime);                     //RADDAT
                                                                                            //RADDAT
         basicStatus(1).systemName                    = ssts0100.systemName;                //RADDAT
         basicStatus(1).currentTime                   = curTimestamp;                       //RADDAT
         basicStatus(1).usersCurrentlySignedOn        = ssts0100.usrSgndOn;                 //RADDAT
         basicStatus(1).batchJobsWaitingForMessages   = ssts0100.jobMsgWait;                //RADDAT
         basicStatus(1).batchJobsRunning              = ssts0100.jobRun;                    //RADDAT
         basicStatus(1).batchJobsHeldWhileRunning     = ssts0100.jobHeldRun;                //RADDAT
         basicStatus(1).batchJobsHeldOnJobQueue       = ssts0100.jobHeldOnJobQ;             //RADDAT
         basicStatus(1).batchJobsOnAHeldJobQueue      = ssts0100.jobOnHeldJobQ;             //RADDAT
         basicStatus(1).batchJobsOnUnassignedJobQueue = ssts0100.jobUnasndJobQ;             //RADDAT
                                                                                            //RADDAT
         EXEC SQL
          SET RESULT SETS FOR RETURN TO CALLER ARRAY :basicStatus
                                                 FOR :numRows      ROWS;                    //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P RetrieveSystemStatus_basic...                                                          RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      * =====================================================================                 RADDAT
      *  Retrieves advanced system status information.                                        RADDAT
      * =====================================================================                 RADDAT
      *  Parameters:                                                                          RADDAT
      *   i_reset          Reset status statistics.                                           RADDAT
      *                     *YES  Statistics will be reset to zero.                           RADDAT
      *                     *NO   Statistics will not be reset to zero.                       RADDAT
      *                                                                                       RADDAT
      *  Returns:                                                                             RADDAT
      *   advancedStatus   Result set with one row of type 'advancedStatus_t'.                RADDAT
      * =====================================================================                 RADDAT
     P RetrieveSystemStatus_advanced...                                                       RADDAT
     P                 B                   export                                             RADDAT
     D RetrieveSystemStatus_advanced...                                                       RADDAT
     D                 PI                                                                     RADDAT
     D  i_reset                      10A   const  varying                                     RADDAT
      *                                                                                       RADDAT
      *  Return value                                                                         RADDAT
     D advancedStatus  DS                  likeds(advancedStatus_t ) inz                      RADDAT
     D                                     dim(1)                                             RADDAT
     D numRows         S             10I 0 inz(%elem(advancedStatus))                         RADDAT
      *                                                                                       RADDAT
      *  Local fields                                                                         RADDAT
     D elapsedTime     S               T   inz                                                RADDAT
     D curTimestamp    S               Z   inz                                                RADDAT
     D ssts0200        DS                  likeds(ssts0200_t) inz                             RADDAT
     D errCode         DS                  likeds(errCode_t ) inz                             RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -               RADDAT
      /free
                                                                                            //RADDAT
 B01     if (i_reset <> '*YES' and i_reset <> '*NO');                                       //RADDAT
            kill('Value of parameter ''i_reset'' is invalid: ' + i_reset);                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         QWCRSSTS(ssts0200: %size(ssts0200): 'SSTS0200': i_reset: errCode);                 //RADDAT
                                                                                            //RADDAT
         curTimestamp = convertSysTimestampToRpg(ssts0200.curDateTime);                     //RADDAT
         elapsedTime  = %time(ssts0200.elapTime: *ISO0);                                    //RADDAT
                                                                                            //RADDAT
         advancedStatus(1).systemName                = ssts0200.systemName;                 //RADDAT
         advancedStatus(1).currentTime               = curTimestamp;                        //RADDAT
         advancedStatus(1).elapsedTime               = elapsedTime;                         //RADDAT
         advancedStatus(1).percentProcessingUnitUsed = ssts0200.przPrcUsd;                  //RADDAT
         advancedStatus(1).jobsInSystem              = ssts0200.jobs;                       //RADDAT
         advancedStatus(1).percentPermanentAddresses = ssts0200.przPrmAddr;                 //RADDAT
         advancedStatus(1).percentTemporaryAddresses = ssts0200.przTmpAddr;                 //RADDAT
         advancedStatus(1).systemASP                 = ssts0200.sysASP;                     //RADDAT
         advancedStatus(1).percentSystemASPUsed      = ssts0200.przSysASPUsd;               //RADDAT
         advancedStatus(1).totalAuxiliaryStorage     = ssts0200.totAuxStg;                  //RADDAT
         advancedStatus(1).numberOfProcessors        = ssts0200.numPrc;                     //RADDAT
         advancedStatus(1).activeJobsInSystem        = ssts0200.actJobs;                    //RADDAT
         advancedStatus(1).mainStorageSize           = ssts0200.mainStgSizeLg;              //RADDAT
         advancedStatus(1).currentDate               = %date();                             //RADDAT
                                                                                            //RADDAT
         EXEC SQL
          SET RESULT SETS FOR RETURN TO CALLER ARRAY :advancedStatus
                                                 FOR :numRows      ROWS;                    //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P RetrieveSystemStatus_advanced...                                                       RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      * =====================================================================                 RADDAT
      *  Retrieves system pool information.                                                   RADDAT
      * =====================================================================                 RADDAT
      *  Parameters:                                                                          RADDAT
      *   i_reset          Reset status statistics.                                           RADDAT
      *                     *YES  Statistics will be reset to zero.                           RADDAT
      *                     *NO   Statistics will not be reset to zero.                       RADDAT
      *                                                                                       RADDAT
      *  Returns:                                                                             RADDAT
      *   poolInfo         Result set with up to 128 rows of type                             RADDAT
      *                    'poolInformation_t'.                                               RADDAT
      * =====================================================================                 RADDAT
     P RetrieveSystemStatus_poolInformation...                                                RADDAT
     P                 B                   export                                             RADDAT
     D RetrieveSystemStatus_poolInformation...                                                RADDAT
     D                 PI                                                                     RADDAT
     D  i_reset                      10A   const  varying                                     RADDAT
      *                                                                                       RADDAT
      *  Return value                                                                         RADDAT
     D poolInfo        DS                  likeds(poolInformation_t) inz                      RADDAT
     D                                     dim(128)                                           RADDAT
     D numRows         S             10I 0 inz(0)                                             RADDAT
      *                                                                                       RADDAT
      *  Local fields                                                                         RADDAT
     D x               S             10I 0 inz                                                RADDAT
     D memSize         S             10I 0 inz                                                RADDAT
     D elapsedTime     S               T   inz                                                RADDAT
     D curTimestamp    S               Z   inz                                                RADDAT
     D ssts0300        DS                  likeds(ssts0300_t        )                         RADDAT
     D                                     based(pSsts0300     )                              RADDAT
     D ssts0300_pool   DS                  likeds(ssts0300_poolInf_t)                         RADDAT
     D                                     based(pSsts0300_pool)                              RADDAT
     D errCode         DS                  likeds(errCode_t         ) inz                     RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -               RADDAT
      /free
                                                                                            //RADDAT
 B01     if (i_reset <> '*YES' and i_reset <> '*NO');                                       //RADDAT
            kill('Value of parameter ''i_reset'' is invalid: ' + i_reset);                  //RADDAT
 E01     endif;                                                                             //RADDAT
                                                                                            //RADDAT
         memSize = 2048;                                                                    //RADDAT
         pSsts0300 = %alloc(memSize);                                                       //RADDAT
                                                                                            //RADDAT
 B01     dou (ssts0300.bytRet <= memSize);                                                  //RADDAT
            QWCRSSTS(ssts0300: memSize: 'SSTS0300': i_reset: errCode);                      //RADDAT
 B02        if (ssts0300.bytAvl > memSize);                                                 //RADDAT
               memSize = ssts0300.bytAvl;                                                   //RADDAT
               pSsts0300 = %realloc(pSsts0300: memSize);                                    //RADDAT
 E02        endif;                                                                          //RADDAT
 E01     enddo;                                                                             //RADDAT
                                                                                            //RADDAT
         curTimestamp = convertSysTimestampToRpg(ssts0300.curDateTime);                     //RADDAT
         elapsedTime  = %time(ssts0300.elapTime: *ISO0);                                    //RADDAT
                                                                                            //RADDAT
 B01     for x = 1 to ssts0300.numPools;                                                    //RADDAT
            poolInfo(x).systemName                = ssts0300.systemName;                    //RADDAT
            poolInfo(x).currentTime               = curTimestamp;                           //RADDAT
            poolInfo(x).elapsedTime               = elapsedTime;                            //RADDAT
                                                                                            //RADDAT
 B02        if (x = 1);                                                                     //RADDAT
               pSsts0300_pool = pSsts0300 + ssts0300.ofsPoolInf;                            //RADDAT
 X02        else;                                                                           //RADDAT
               pSsts0300_pool = pSsts0300_pool + ssts0300.lenPoolInf;                       //RADDAT
 E02        endif;                                                                          //RADDAT
                                                                                            //RADDAT
            poolInfo(x).systemPool         = ssts0300_pool.systemPool;                      //RADDAT
            poolInfo(x).poolSize           = ssts0300_pool.poolSize;                        //RADDAT
            poolInfo(x).reservedSize       = ssts0300_pool.reservedSize;                    //RADDAT
            poolInfo(x).maxActThd          = ssts0300_pool.maxActThd;                       //RADDAT
            poolInfo(x).db_faults          = ssts0300_pool.db_faults;                       //RADDAT
            poolInfo(x).db_pages           = ssts0300_pool.db_pages;                        //RADDAT
            poolInfo(x).nonDB_faults       = ssts0300_pool.nonDB_faults;                    //RADDAT
            poolInfo(x).nonDB_pages        = ssts0300_pool.nonDB_pages;                     //RADDAT
            poolInfo(x).actToWait          = ssts0300_pool.actToWait;                       //RADDAT
            poolInfo(x).waitToIneligible   = ssts0300_pool.waitToIneligible;                //RADDAT
            poolInfo(x).activeToIneligible = ssts0300_pool.activeToIneligible;              //RADDAT
            poolInfo(x).poolName           = ssts0300_pool.poolName;                        //RADDAT
            poolInfo(x).sbsName            = ssts0300_pool.sbsName;                         //RADDAT
            poolInfo(x).sbsLibName         = ssts0300_pool.sbsLibName;                      //RADDAT
            poolInfo(x).pagingOption       = ssts0300_pool.pagingOption;                    //RADDAT
                                                                                            //RADDAT
            numRows = numRows + 1;                                                          //RADDAT
 E01     endfor;                                                                            //RADDAT
                                                                                            //RADDAT
         dealloc(N) pSsts0300;                                                              //RADDAT
                                                                                            //RADDAT
         EXEC SQL
          SET RESULT SETS FOR RETURN TO CALLER ARRAY :poolInfo
                                                 FOR :numRows      ROWS;                    //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
         begsr *pssr;                                                                       //RADDAT
 B01        if (pSsts0300 <> *NULL);                                                        //RADDAT
               dealloc(N) pSsts0300;                                                        //RADDAT
 E01        endif;                                                                          //RADDAT
            return;                                                                         //RADDAT
         endsr;                                                                             //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P RetrieveSystemStatus_poolInformation...                                                RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      * =====================================================================                 RADDAT
      *  Returns 'about' information about the RetrieveSystemStatus                           RADDAT
      *  web service.                                                                         RADDAT
      * =====================================================================                 RADDAT
      *  Parameters:                                                                          RADDAT
      *   o_version        Version number of the Web Service.                                 RADDAT
      *   o_copyright      Copyright information.                                             RADDAT
      *   o_info           General information about the Web Service.                         RADDAT
      *                                                                                       RADDAT
      *  Returns:                                                                             RADDAT
      *   void                                                                                RADDAT
      * =====================================================================                 RADDAT
     P RetrieveSystemStatus_about...                                                          RADDAT
     P                 B                   export                                             RADDAT
     D RetrieveSystemStatus_about...                                                          RADDAT
     D                 PI                                                                     RADDAT
     D  o_version                    10A          varying                                     RADDAT
     D  o_copyright                 512A          varying                                     RADDAT
     D  o_info                     1024A          varying                                     RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -               RADDAT
      /free
                                                                                            //RADDAT
         o_version   = '1.0.0';                                                             //RADDAT
         o_copyright = '2009, Thomas Raddatz';                                              //RADDAT
         o_info      = 'The purpose of the ''RetrieveSystemStatus'' Web +
                        Service is to demonstrate how to provide a Web +
                        Service using RPG, SQL and Java.' + CRLF +
                       'It has been developed as a sample for the +
                        German Common Conference 2009 in Schweinfurt.' + CRLF +             //RADDAT
                       'This request has been served by job: ' + getJob();                  //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P RetrieveSystemStatus_about...                                                          RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      * =====================================================================                 RADDAT
      *  Returns the qualified name of the current job.                                       RADDAT
      * =====================================================================                 RADDAT
     P getJob...                                                                              RADDAT
     P                 B                                                                      RADDAT
     D getJob...                                                                              RADDAT
     D                 PI            26A   varying                                            RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -               RADDAT
      /free
                                                                                            //RADDAT
         return %char(sds.nbr) + '/' + %trim(sds.user) + '/' + %trim(sds.job);              //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P getJob...                                                                              RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      * =====================================================================                 RADDAT
      *  Converts a given system timestamp as returned by several APIs                        RADDAT
      *  to a RPG timestamp value.                                                            RADDAT
      * =====================================================================                 RADDAT
     P convertSysTimestampToRpg...                                                            RADDAT
     P                 B                                                                      RADDAT
     D convertSysTimestampToRpg...                                                            RADDAT
     D                 PI              Z                                                      RADDAT
     D  i_sysTmstmp                   8A   const                                              RADDAT
      *                                                                                       RADDAT
     D curTimestamp    S               Z   inz                                                RADDAT
      *                                                                                       RADDAT
     D curDateTime     DS                  likeds(QWCCVTDT_dateTime_20_t ) inz                RADDAT
     D errCode         DS                  likeds(errCode_t              ) inz                RADDAT
     D timezone        DS                  likeds(QWCCVTDT_timezone_t    ) inz                RADDAT
      *                                                                                       RADDAT
      *  Convert Date and Time Format (QWCCVTDT) API                                          RADDAT
     D QWCCVTDT...                                                                            RADDAT
     D                 PR                         extpgm('QWCCVTDT')                          RADDAT
     D  i_iFormat                    10A   const                                              RADDAT
     D  i_iValue                  65535A   const options(*varsize)                            RADDAT
     D  i_oFormat                    10A   const                                              RADDAT
     D  o_oValue                  65535A          options(*varsize)                           RADDAT
     D  io_errCode                65535A          options(*varsize)                           RADDAT
     D  i_iTimezone                  10A   const  options(*nopass)              | optGrp 1    RADDAT
     D  i_oTimezone                  10A   const  options(*nopass)              |             RADDAT
     D  o_timezone                65535A          options(*nopass: *varsize)    |             RADDAT
     D  i_lenTimezone                10I 0 const  options(*nopass)              |             RADDAT
     D  i_precInd                     1A   const  options(*nopass)              |             RADDAT
     D  i_iTimeInd                    1A   const  options(*nopass)              | optGrp 2    RADDAT
      *                                                                                       RADDAT
      *  Time Zone Information Value Structure                                                RADDAT
     D QWCCVTDT_timezone_t...                                                                 RADDAT
     D                 DS                  qualified               based(pDummy)              RADDAT
     D  bytRet                 1      4I 0                                                    RADDAT
     D  bytAvl                 5      8I 0                                                    RADDAT
     D  desc                   9     18A                                                      RADDAT
     D  reserved_1            19     19A                                                      RADDAT
     D  dayLightInd           20     20A                                                      RADDAT
     D  curOffset             21     24I 0                                                    RADDAT
     D  curFullName           25     74A                                                      RADDAT
     D  curAbbrevName         75     84A                                                      RADDAT
     D  curMsgInd             85     91A                                                      RADDAT
     D  msgFile               92    101A                                                      RADDAT
     D  msgFileLib           102    111A                                                      RADDAT
      *                                                                                       RADDAT
      *  This table shows the structure used for the input and output variables when          RADDAT
      *  the format is *JOB, *SYSVAL, *YMD, *MDY, *DMY, and *JUL and the precision            RADDAT
      *  indicator specifies milliseconds.                                                    RADDAT
     D QWCCVTDT_dateTime_16_t...                                                              RADDAT
     D                 DS                  qualified               based(pDummy)              RADDAT
     D  century                1      1A                                                      RADDAT
     D  date                   2      7A                                                      RADDAT
     D  time                   8     13A                                                      RADDAT
     D  mSecs                 14     16A                                                      RADDAT
      *                                                                                       RADDAT
      *  This table shows the structure used for the input and output variables when          RADDAT
      *  the format is *YYMD, *MDYY, *DMYY, and *LONGJUL and the precision indicator          RADDAT
      *  specifies milliseconds.                                                              RADDAT
     D QWCCVTDT_dateTime_17_t...                                                              RADDAT
     D                 DS                  qualified               based(pDummy)              RADDAT
     D  date                   1      8A                                                      RADDAT
     D  time                   9     14A                                                      RADDAT
     D  mSecs                 15     17A                                                      RADDAT
      *                                                                                       RADDAT
      *  This table shows the structure used for the input and output variables when          RADDAT
      *  the format is *JOB, *SYSVAL, *YMD, *MDY, *DMY, and *JUL and the precision            RADDAT
      *  indicator specifies microseconds.                                                    RADDAT
     D QWCCVTDT_dateTime_19_t...                                                              RADDAT
     D                 DS                  qualified               based(pDummy)              RADDAT
     D  century                1      1A                                                      RADDAT
     D  date                   2      7A                                                      RADDAT
     D  time                   8     13A                                                      RADDAT
     D  mSecs                 14     19A                                                      RADDAT
      *                                                                                       RADDAT
      *  This table shows the structure used for the input and output variables when          RADDAT
      *  the format is *YYMD, *MDYY, *DMYY, and *LONGJUL and the precision indicator          RADDAT
      *  specifies microseconds.                                                              RADDAT
     D QWCCVTDT_dateTime_20_t...                                                              RADDAT
     D                 DS                  qualified               based(pDummy)              RADDAT
     D  date                   1      8A                                                      RADDAT
     D  time                   9     14A                                                      RADDAT
     D  mSecs                 15     20A                                                      RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -               RADDAT
      /free
                                                                                            //RADDAT
         QWCCVTDT('*DTS': i_sysTmstmp: '*YYMD': curDateTime: errCode
                  : '*JOB': '*JOB': timezone: %size(timezone): '1');                        //RADDAT
                                                                                            //RADDAT
         curTimestamp = %date(curDateTime.date: *ISO0) +
                        %time(curDateTime.time: *ISO0) +
                        %mseconds(%int(curDateTime.mSecs));                                 //RADDAT
                                                                                            //RADDAT
         return curTimestamp;                                                               //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P convertSysTimestampToRpg...                                                            RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      * =====================================================================                 RADDAT
      *  Kills the current process and sends a given message text.                            RADDAT
      * =====================================================================                 RADDAT
     P kill...                                                                                RADDAT
     P                 B                                                                      RADDAT
     D kill...                                                                                RADDAT
     D                 PI                                                                     RADDAT
     D  i_text                      512A   const  varying                                     RADDAT
      *                                                                                       RADDAT
     D msgKey          S              4A   inz                                                RADDAT
     D qMsgF           DS                  qualified inz                                      RADDAT
     D  name                         10A                                                      RADDAT
     D  lib                          10A                                                      RADDAT
     D errCode         DS                  likeds(errCode_t   ) inz                           RADDAT
      *                                                                                       RADDAT
      *  Send Program Message (QMHSNDPM) API                                                  RADDAT
     D QMHSNDPM        PR                         extpgm('QMHSNDPM')                          RADDAT
     D   i_msgID                      7A   const                                              RADDAT
     D   i_qMsgF                     20A   const                                              RADDAT
     D   i_msgData                32767A   const  options(*varsize )                          RADDAT
     D   i_length                    10I 0 const                                              RADDAT
     D   i_msgType                   10A   const                                              RADDAT
     D   i_callStkE               32767A   const  options(*varsize )                          RADDAT
     D   i_callStkC                  10I 0 const                                              RADDAT
     D   o_msgKey                     4A                                                      RADDAT
     D   io_ErrCode               32767A          options(*varsize )                          RADDAT
     D   i_lenStkE                   10I 0 const  options(*nopass  )                          RADDAT
     D   i_callStkEQ                 20A   const  options(*nopass  )                          RADDAT
     D   i_wait                      10I 0 const  options(*nopass  )                          RADDAT
     D   i_callStkEDT                10A   const  options(*nopass  )                          RADDAT
     D   i_ccsid                     10I 0 const  options(*nopass  )                          RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -               RADDAT
      /free
                                                                                            //RADDAT
         clear qMsgF;                                                                       //RADDAT
         qMsgF.name = 'QCPFMSG';                                                            //RADDAT
         qMsgF.lib  = '*LIBL';                                                              //RADDAT
                                                                                            //RADDAT
         clear errCode;                                                                     //RADDAT
         errCode.bytPrv = %size(errCode);                                                   //RADDAT
                                                                                            //RADDAT
         QMHSNDPM('CPF9898': qMsgF: i_text: %len(i_text): '*ESCAPE'
                  : '*': 1: msgKey: errCode);                                               //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /end-free
      *                                                                                       RADDAT
     P kill...                                                                                RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
