package de.tools400.jako2009.webservice.retrievesystemstatus.test;

import de.tools400.jako2009.webservice.retrievesystemstatus.server.BasicStatusRequest;
import de.tools400.jako2009.webservice.retrievesystemstatus.server.BasicStatusResponse;
import de.tools400.jako2009.webservice.retrievesystemstatus.server.SystemStatusService;

public class TestRetrieveBasicStatus {

	/**
	 * Prft nur, ob der Aufruf der Stored Procedure funktioniert.
	 * Prft nicht, ob der Web Service funktioniert.
	 */
	public static void main(String[] args) {
		
		SystemStatusService aService = new SystemStatusService();
		
		BasicStatusRequest aRequest = new BasicStatusRequest();
		aRequest.setReset(false);
		
		BasicStatusResponse aResponse = aService.retrieveBasicStatus(aRequest);
		
		System.out.println("Basic System Status:\n");
		System.out.println("  Batch jobs running              : " + aResponse.getBatchJobsRunning());
		System.out.println("  Batch jobs waiting for messages : " + aResponse.getBatchJobsWaitingForMessages());
		
	}

}
